/**************************************************************************
 *
 * FILE  encoding.h
 * Copyright (c) 2015 Daniel Kahlin <daniel@kahlin.net>
 * Written by Daniel Kahlin <daniel@kahlin.net>
 *
 * DESCRIPTION
 *   create encoding structure
 *
 ******/
#ifndef ENCODING_H
#define ENCODING_H

#include <stdint.h>
#include <stdlib.h>

#include "match.h"

typedef struct {
    int n;
    size_t cost;
    Match *path;
    uint8_t *buf;
    size_t len;
} MatchPath;

MatchPath *create_matchpath(int n, uint8_t *buf);
void destroy_matchpath(MatchPath *mp);


typedef struct EncodingSet EncodingSet;

typedef struct {
    int (*cost_lit)(EncodingSet *es, int l);
    int (*cost_mlen)(EncodingSet *es, int l);
    int (*cost_moffs)(EncodingSet *es, int of, int l);
} CostFuncSet;

MatchPath *find_cheapest_path(MatchTree *mt, CostFuncSet *cfs, EncodingSet *es);


#endif /* ENCODING_H */
/* eof */
